#!/usr/local/bin/python

from Tkinter  import *                                 # widgets
from guitools import frame, button, entry              # widget builders

class CalcGui(Frame):
    def __init__(self):                                # an extended frame
        Frame.__init__(self)                           # on default top-level
        self.pack({'expand':'yes', 'fill':'both'})     # all parts expandable
        self.master.minsize(1, 1)                      # make root resizable too
        self.master.title('Python Calculator 0.1')     # 6 frames plus entry
        self.master.iconname("pcalc1")

        self.names = {}                                # namespace for variables
        text = StringVar()
        entry(self, 'top', text)

        rows = ["abcd", "0123", "4567", "89()"]
        for row in rows:
            frm = frame(self, 'top')
            for char in row: button(frm, 'left', char, 
                               lambda x=text, y=char: x.set(x.get() + y))

        frm = frame(self, 'top')
        for char in "+-*/=": button(frm, 'left', char,
                               lambda x=text, y=char: x.set(x.get()+' '+y+' '))

        frm = frame(self, 'bottom')
        button(frm, 'left', 'eval',  lambda x=self, y=text: x.eval(y) )
        button(frm, 'left', 'clear', lambda x=text: x.set('') )

    def eval(self, text):
        try:
            text.set(`eval(text.get(), self.names, self.names)`)
        except SyntaxError:
            try:
                exec(text.get(), self.names, self.names)  
            except:
                text.set("ERROR")         # bad as statement too?
            else:
                text.set('')              # worked as a statement
        except:
            text.set("ERROR")             # other eval expression errors

if __name__ == '__main__': CalcGui().mainloop()
