#!/usr/local/bin/python
from apptools import StreamApp          # get the superclass
from textpack import marker             # get a marker constant

class PackApp(StreamApp):               # define a class
    def start(self):                    # define some methods
        if not self.args:
            self.exit('use: packapp.py [-o target]? src src...')
        
    def help(self):
        StreamApp.help(self)            # show superclass args
        print '<file> <file>...'        # then show my args 

    def run(self):
        for name in self.restargs():
            try:
                self.message('packing: ' + name)
                self.pack_file(name)
            except:
                self.exit('error processing: ' + name)
    
    def pack_file(self, name):  
        self.setInput(name)           
        self.write(marker + name + '\n')
        while 1:
            line = self.readline()
            if not line: break
            self.write(line)                      # copy until eof

if __name__ == '__main__':  PackApp().main()      # if run as a script
